﻿<?php
import namespace System;
import namespace Zennolab:::CommandCenter;
import namespace Emulations;

class Step1
{
	// It's simple example which uses Emulator for emulation
	// parameter "instance" Instance object
	public function Execute($instance)
	{
		// Clear cookie
		$instance->ClearCookie();

		// Go to youtube.com
		$tb = $instance->MainTab;
		if (($tb->IsVoid) || ($tb->IsNull)) return -1;
		if ($tb->IsBusy) $tb->WaitDownloading();
		$tb->Navigate("youtube.com");
		if ($tb->IsBusy) $tb->WaitDownloading();

		// Click on button "Create account"
		$he = $instance->GetTabByAddress("page")->GetDocumentByAddress("0")->FindElementByAttribute("a", "href", "http://www.youtube.com/signup\\?next=%2F", "regexp", 0);
		if ($he->IsVoid) return -1;

		// Set focus on this html element (it's not necessarily for LeftMouseClick but I recommend this do)
		$he->Focus();
			
		// Now uses emulator for click on button
		Emulator::LeftMouseClick($instance->MainTab->Handle, $he);
			
		// If you clicked on button which to redirect a tab to another url you should wait downloading of tab (it's very often mistake)
		if ($tb->IsBusy) $tb->WaitDownloading();

		// Search element for email entering
		$he = $instance->GetTabByAddress("page")->GetDocumentByAddress("0")->FindElementByTag("form", 0)->FindChildByName("Email");
		if ($he->IsVoid) {
			$he = $instance->GetTabByAddress("page")->GetDocumentByAddress("0")->FindElementByTag("form", 0)->FindChildById("Email");
		}
		if ($he->IsVoid) {
			$he = $instance->GetTabByAddress("page")->GetDocumentByAddress("0")->FindElementByTag("form", 0)->FindChildByAttribute("input:text", "fulltag", "input:text", "text", 0);
		}
		if ($he->IsVoid) return -1;

		// Set focus on this html element (it's necessarily for SendString or SendText)
		$he->Focus();
			
		// Enter email with delay 100-200 ms
		Emulator::SendString($instance->MainTab->Handle, $instance->RiseMacros("Person.HumanLogin", array( "[Eng|4][RndNum|1970|1990]" ))."@mail.com", 100, 200);

		// Search element for password entering
		$he = $instance->GetTabByAddress("page")->GetDocumentByAddress("0")->FindElementByTag("form", 0)->FindChildByName("Passwd");
		if ($he.IsVoid) {
			$he = $instance->GetTabByAddress("page")->GetDocumentByAddress("0")->FindElementByTag("form", 0)->FindChildById("Passwd");
		}
		if ($he->IsVoid) {
			$he = $instance->GetTabByAddress("page")->GetDocumentByAddress("0")->FindElementByTag("form", 0)->FindChildByAttribute("input:password", "fulltag", "input:password", "text", 0);
		}
		if ($he->IsVoid) return -1;

		// Generating password
		$password = $instance->RiseMacros("Random.Text", array( "10", "cd" )); 

		// Set focus on this html element (it's necessarily for SendString or SendText)
		$he->Focus();
			
		// Enter password with delay 100-200 ms
		Emulator::SendString($instance->MainTab->Handle, $password, 100, 200);
			
		// Search element for password entering again
		$he = $instance->GetTabByAddress("page")->GetDocumentByAddress("0")->FindElementByTag("form", 0)->FindChildByName("PasswdAgain");
		if ($he->IsVoid) {
			$he = $instance->GetTabByAddress("page")->GetDocumentByAddress("0")->FindElementByTag("form", 0)->FindChildById("PasswdAgain");
		}
		if ($he->IsVoid) {
			$he = $instance->GetTabByAddress("page")->GetDocumentByAddress("0")->FindElementByTag("form", 0)->FindChildByAttribute("input:password", "fulltag", "input:password", "text", 1);
		}
		if ($he->IsVoid) return -1;

		// Set focus on this html element (it's necessarily for SendString or SentText)
		$he->Focus();
			
		// Enter password again with delay 100-200 ms
		Emulator::SendString($instance->MainTab->Handle, $password, 100, 200);

		// Defocus last html element that code creator doesn't adds code on editor
		$he->RiseEvent("blur", false);			

		return 0;
	}
}
?>


